/* Du förväntas inte nu förstå alla detaljer i koden.
   Exemplet tas upp för att visa vad JavaScript kan användas till.
   Vi tittar endast lite översiktligt på strukturen och koppling mellan HTML och JavaScript. */
// --------------------------------------------------
// Globala variabler
let formElem;	// Elementet för formuläret
let msgElem;	// Element för meddelande
let resElem;	// Element för resultat
// --------------------------------------------------
// Initiering då webbsidan är inläst
function init() {
    let rangeElem, numberElem; // Referenser till elementen för range och number
    formElem = document.querySelector("#loanForm");
    msgElem = document.querySelector("#message");
    resElem = document.querySelector("#result");
    // Gränser och initialt värde för lånebelopp samt koppla input till funktioner
    numberElem = formElem.amount;
    rangeElem = numberElem.previousElementSibling;
    if (rangeElem.type != "range") rangeElem.style.display = "none";
    rangeElem.min = numberElem.min = 10000;
    rangeElem.max = numberElem.max = 400000;
    rangeElem.value = numberElem.value = 100000;
    rangeElem.step = numberElem.step = 10000;
    rangeElem.addEventListener("input", updateNumber);
    numberElem.addEventListener("input", updateRange);
    // Gränser och initialt värde för ränta samt koppla input till funktioner
    numberElem = formElem.interest;
    rangeElem = numberElem.previousElementSibling;
    if (rangeElem.type != "range") rangeElem.style.display = "none";
    rangeElem.min = numberElem.min = 0;
    rangeElem.max = numberElem.max = 9;
    rangeElem.value = numberElem.value = 2;
    rangeElem.step = numberElem.step = 0.1;
    rangeElem.addEventListener("input", updateNumber);
    numberElem.addEventListener("input", updateRange);
    formElem.calcBtn.addEventListener("click", calculatePayment);
} // End init
window.addEventListener("load", init);
// --------------------------------------------------
// Uppdatera fältet med tal utifrån skjutreglaget
function updateNumber() {
    this.nextElementSibling.value = this.value;
} // End updateNumber
// --------------------------------------------------
// Uppdatera skjutreglaget utifrån fältet med tal
function updateRange() {
    this.previousElementSibling.value = this.value;
} // End updateRange
// --------------------------------------------------
// Kontrollera typ av lån och gå till någon av beräkningsfunktionerna
function calculatePayment() {
    let a = formElem.amount.value;      // Önskat lånebelopp
    let i = formElem.interest.value;    // Räntesats i procent
    let n = formElem.nrOfYears.value;   // Antal år
    let tot; // Total lånekostnad
    msgElem.innerHTML = "";
    resElem.innerHTML = "";
    if (a == "" || a < 10000 || a > 400000) {
        msgElem.innerText = "Lånebeloppet måste vara mellan 10 000 och 400 000 kr";
        return; // Avbryt funktionen
    }
    if (i == "" || i < 0 || i > 9) {
        msgElem.innerText = "Räntan måste vara mellan 0 och 9 %";
        return; // Avbryt funktionen
    }
    i = i / 100 / 12;  // Räntesats per månad
	n = n * 12;        // Antal månader
    if (formElem.payment.value == "p1") tot = calculateAnnuity(a, i, n);
    else tot = calculateFixedInstallment(a, i, n);
    msgElem.innerHTML += "<h4>Total kostnad för lånet</h4><p>" + parseInt(tot) + " kr</p>"
} // End calculatePayment
// --------------------------------------------------
// Beräkna månadskostnad för annuitetslån
function calculateAnnuity(amount, interest, nrOfMonth) {
    let payment; // Betalning per månad
    let totCost; // Total kostnad för lånet
    if (interest == 0) payment = amount / nrOfMonth;
    else payment = amount * interest / (1 - (1 + interest) ** (-nrOfMonth));
    resElem.innerHTML = parseInt(payment) + " kr per månad";
    totCost = nrOfMonth * payment;
    return totCost; // Returnera den totla kostnaden
} // End calculateAnnuity
// --------------------------------------------------
// Beräkna månadskostnad för rak amortering
function calculateFixedInstallment(amount, interest, nrOfMonth) {
    let amortization = amount / nrOfMonth; // Amortering per månad
    let htmlCode = ""; // Textsträng med utskrift
    let totCost = 0; 	// Total kostnad för lånet
    for (let month = 1; month <= nrOfMonth; month++) {
        let payment = amortization + amount * interest; // Betalning per månad
        amount = amount - amortization;
        htmlCode += "Månad " + month + ": " + parseInt(payment) + " kr<br>";
        totCost = totCost + payment;
    }
    resElem.innerHTML = htmlCode;
    return totCost; // Returnera den totla kostnaden
} // End calculateFixedInstallment
// --------------------------------------------------
